// JavaScript Document
(function(){
//Toggle top navbar (responsive)
function toggleBarnav(opt=2, trans=true)
{
	if(trans)
		bNav.style.transition="all ease-in-out 250ms";
	switch (opt){
		case 1:
		bNav.classList = "navbar navbar-expand-lg navbar-dark bg-dark py-0 fixed-top"
		break
		case 0:
		bNav.classList = "navbar navbar-expand-lg navbar-light bg-light py-3 fixed-top"
	}
	bNav.modoIni = bNav.classList.contains('py-3')	
}
//Change top navbar when scrolling
function ctrlBarnav(){
	/*Cambia aspecto barra menu superior a negra estrecha (1) o alta clara (0)*/
	if ( event.currentTarget.scrollTop > 5 && bNav.modoIni)
		toggleBarnav(1)
	if ( event.currentTarget.scrollTop <= 1 && !bNav.modoIni)
		toggleBarnav(0)
}
//Javascript parallax for langs image in services section
function flotarImag(){
	var delta = this.scrollAnt > this.scrollTop?2:-2
	this.scrollAnt = this.scrollTop
	if(imgFlot.style.top === '') imgFlot.style.top = 0
	if (imgFlot.dataset.vista == "true")
		{
		imgFlot.style.top = parseInt(imgFlot.style.top) + delta + 'px'
		}
}

/*Counter */
function contar()
{
var obCont= document.getElementById('contador');
var ds = obCont.dataset;
var max = parseInt(ds.max);
var vel = parseInt(ds.vel)
var ini = parseInt(ds.start)
if (ini <= max)
	{
	obCont.dataset.start = ini + parseInt(ds.incr)
	window.timer=window.setTimeout(contar, vel)
	obCont.innerHTML = ini
	}
  else
  	window.clearTimeout(window.timer);
}

var iniContador = new IntersectionObserver(function(entries) {
	if (entries[0].isIntersecting )
		{
		contar();
		this.unobserve(entries[0].target);
		}
}, { root: null, threshold:1});

var ctrlImgFlot = new IntersectionObserver(function(entries) {
		if (entries[0].isIntersecting )
			entries[0].target.dataset.vista = true
		else
			{
			entries[0].target.dataset.vista = false
			entries[0].target.style.top = entries[0].target.dataset.ini
			}
}, { root: null, threshold:0.1});


/*Animates Scroll*/
/*Parallax is set inside main section */
function scrollInt(lbl)
{
    var links = document.getElementsByClassName(lbl);
    for (var lnk of links) 
		{
		lnk.addEventListener('click',animScroll, false)
		};
}

//Scroll for internals links
function animScroll()
{	 
	var id, dst, opt, offset=0;
	event.preventDefault();
	id= event.currentTarget.hash.replace(/#/,'');
	dst = document.getElementById(id);
	/*barnav inicial es py-0 y la estrecha es py-3 : 3 rems de diferencia. Convertir a px */	
	if(bNav.modoIni)
		offset = 3*parseFloat(getComputedStyle(document.documentElement).fontSize);
	opt = {
		left:0,
		top: dst.offsetTop -bNav.offsetHeight + offset,
		behavior: 'smooth'
		}	
	sMain.scroll(opt);
}

//Change style for inut and textarea controls with focus
function focusIn()
{
	let campo = event.currentTarget;
	let control=campo.getElementsByClassName('form-control')[0];
	if (campo.dataset.activo != 1){
		control.focus();
		campo.dataset.activo = 1
		control.addEventListener('blur', focusOut)
	}
}
//Controls: focusout change control style and right icons
function focusOut()
{
	let control = event.currentTarget.parentElement;
    let valor = control.querySelector(".form-control");
    let req = control.querySelector(".requerido");
    if (valor !=null && req != null)
        {
        if (valor.value != "")
            req.innerHTML='<i class="bi bi-check2"></i>';
        else
            req.innerHTML='<i class="bi bi-exclamation-circle"></i>';
        }    
	control.dataset.activo = 0;
	control.removeEventListener('blur', focusOut)
}

function setForm(nmb)
{ 
	var form = document.getElementById(nmb);
	var lst = form.getElementsByClassName('control-group')
	lst = [...lst]
	lst.forEach(function(v){v.addEventListener('click', focusIn)})	
    form.addEventListener('submit', sendForm);
}
//Fetch for processing form
function sendForm()
{
   event.preventDefault();
   const data = new FormData(event.target);
   fetch("contactus.php", {method:"POST", body: data})
       .then(function(response) {
              if (!response.ok) {
                  let vnt = document.getElementById('respForm');
                  let cont = vnt.querySelector('.modal-body');
                  cont.innerHTML="<p>There was an error. Please, retry after a minutes</p>";
                  vnt=bootstrap.Modal.getOrCreateInstance(vnt);
                  vnt.show();
                  }
              return response.text();
            })
       .then(function(response) {
              let vnt = document.getElementById('respForm');
              let cont = vnt.querySelector('.modal-body');
              cont.innerHTML="<p>Thank you for contacting us</p>";
              vnt=bootstrap.Modal.getOrCreateInstance(vnt);
              vnt.show();
            })
}



/*Set height for reference block of scrolling image in services region*/
function setAltoMarco(marco, idref)
{
	var ref = document.getElementById(idref);
	var alt = parseInt(window.getComputedStyle(ref).getPropertyValue('height'))
	marco.style['max-height'] = alt+"px";
}

var sMain= document.getElementById('main')
sMain.addEventListener('scroll', ctrlBarnav);
sMain.addEventListener('scroll', flotarImag);
var bNav = document.getElementById('barnav')
bNav.addEventListener('transitionend',function(){ this.style.removeProperty("transition");})
var imgFlot = document.getElementById('imgFlot')

iniContador.observe(document.getElementById("contador"));

setAltoMarco(imgFlot.parentElement, 'txtmov')
ctrlImgFlot.observe(imgFlot);

scrollInt('nav-link')
setForm('contactar')
toggleBarnav()
})();
